function on.paint(gc)
 if not init then
  numlist = {3,3,3,3}
  placelist = {0,0,0,0}
  reveal = false
  gameover = false
  colors = {{255,0,0},{255,255,0},{0,255,0},{0,0,255}}
 end
 gc:setColorRGB(0,0,0)
 for i=1,15 do
  gc:drawLine(20*i+20,10,20*i+20,150)
 end
 for i=1,4 do
  gc:setColorRGB(0,0,0)
  gc:drawLine(80*i-40,190,80*i-40,220)
  gc:drawLine(80*i-55,200,80*i-20,200)
  if reveal then
   gc:setFont("sansserif","r",12)
   gc:drawLine(80*i-20,200,80*i-20,180)
   gc:drawRect(80*i-25,155,20,25)
   gc:drawString(numlist[i],80*i-20,155,"top")
  end
  gc:setColorRGB(unpack(colors[i]))
  gc:fillRect(20*placelist[i],25*i,40,20)
  gc:drawRect(80*i-50,170,20,20)
 end
 if gameover == true then
  gc:setFont("serif","b",16)
  gc:drawString("Game Over",150,100)
 end
 gc:setFont("sansserif","r",8)
 gc:drawString("by cyanophycean314",1,208)
end

function on.charIn(key)
 if not gameover and not reveal and (key == "1" or key == "3" or key == "5") then
  numlist[1] = tonumber(key)
  for i=1,4 do
   if i > 1 then
    bc = math.random(7)
    if bc < 3 then
      abc = 1
    elseif bc < 5 then
     abc = 3
    else
     abc = 5
    end
    numlist[i] = abc
   end
  end
  if numlist[4] ~= numlist[1] and numlist[4] ~= numlist[2] and numlist[4] ~= numlist[3] then
   placelist[4] = placelist[4] + numlist[4]
  end
  if numlist[1] ~= numlist[2] and numlist[1] ~= numlist[3] and numlist[1] ~= numlist[4] then
   placelist[1] = placelist[1] + numlist[1]
  end
  if numlist[1] ~= numlist[2] and numlist[2] ~= numlist[3] and numlist[2] ~= numlist[4] then
   placelist[2] = placelist[2] + numlist[2]
  end
  if numlist[1] ~= numlist[3] and numlist[3] ~= numlist[2] and numlist[4] ~= numlist[3] then
   placelist[3] = placelist[3] + numlist[3]
  end
  reveal = true
 end
 for i=1,4 do
  if placelist[i] >= 14 then
   placelist[i] = 14
   gameover = true
  end
 end
 init = true
 platform.window:invalidate()
end

function on.enterKey()
 reveal = not reveal
 init = true
 platform.window:invalidate()
end

function on.tabKey()
 init = false
 platform.window:invalidate()
end